﻿using SqlSugar;
using System;
using System.Runtime.Serialization;

namespace WCS.Entity
{
    /// <summary>
    ///  码垛主表
    /// </summary>
    [Tenant("sx")]
    [SugarTable("Palletizing")]
    public partial class Palletizing
    {    /// <summary>
         /// ID
         /// </summary>
        [SugarColumn(IsPrimaryKey = true, ColumnDescription = "ID"), DataMember(Order = 0)]
        public long ID { get; set; }

        /// <summary>
        /// 码垛工位
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 100, IsNullable = false)]
        public string Equip { get; set; }

        /// <summary>
        /// 最大码垛数量
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int PalletMax { get; set; }

        /// <summary>
        /// 码垛状态（0：执行；1.结束码垛）
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int PalletizState { get; set; }

        /// <summary>
        /// 是否强制结盘
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int Finish { get; set; }

        /// <summary>
        /// 装箱规则（CP：层配；SPC：非空置盘）
        /// </summary>
        [SugarColumn]
        public string BoxRule { get; set; }

        /// <summary>
        /// 装箱规则id
        /// </summary>
        [SugarColumn(ColumnDataType = "bit", IsNullable = false)]
        public long BoxRuleId { get; set; }

        /// <summary>
        /// 托盘输送任务
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int TaskNum { get; set; }

        public int Count { get; set; }

        public int GoodsType { get; set; }

        public DateTime AddTime { get; set; }

        /// <summary>
        /// 所属机械臂
        /// </summary>
        [SugarColumn]
        public string Robot { get; set; }
    }
}
