﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WCS.Core;
using WCS.Entity.Protocol.Station;
using WCS.WorkEngineering.Worlds;
using WCS.WorkEngineering.Extensions;
using ServiceCenter.SqlSugars;
using WCS.Entity.Protocol.BCR;
using WCS.Entity.Protocol.QT;
using WCS.WorkEngineering.WebApi.Models.WCS.Request;
using Newtonsoft.Json;
using WCS.Entity;
using SqlSugar;

namespace WCS.WorkEngineering.Systems.扭转检测
{
    [BelongTo(typeof(MainWorld))]
    [Description("机台分配")]
    public class 机台分配 : DeviceSystem<Device<IStation520, IStation521, IStation523>>
    {
        bool flag;
        protected override bool ParallelDo => false;
         

        public override void Do(Device<IStation520, IStation521, IStation523> obj)
        {
            if (obj.Data.VoucherNo != obj.Data2.VoucherNo)
            {
                World.Log("PLC正在处理");
                return;
            }
            if (obj.Data2.Request == 0)
            {
                World.Log("无请求");
                return;
            }
            World.Log($"扭转机台分配{obj.Entity.Code}交互开始时间:一个周期" + DateTime.Now.ToString("yyyyMMddHHmmss"));
            var targets = Device.All.Where(v => v.HasProtocol<IBCR81>() && v.HasFlag("扭转检测"))
             .Where(v =>
             {
                 var dev = v.Targets.First();
                 var qt = dev.Protocol<IQT51>(this.World);
                 return qt.Enable ==QTStatus.启用&&qt.RunStatus==QTRunStatus.空闲&&qt.Fault == QTFault.非异常;
             })
             .Select(v => short.Parse(v.Code))
             .Where(v => v > short.Parse(obj.Entity.Code))
             .ToArray();
            if (targets.Length == 0)
            {
                World.Log($"扭转机台分配{obj.Entity.Code}交互结束时间:一个周期" + DateTime.Now.ToString("yyyyMMddHHmmss"));
                MainWorld.Redis.Set($"Sx:WCSErrorInfo:{obj.Entity.Code}", JsonConvert.SerializeObject(new RedisError() { Equip = obj.Entity.Code, Con = obj.Entity.Code + "所有机台不可用", Time = DateTime.Now }));
                throw new Exception("所有机台不可用");
            }

            //if (obj.Entity.Code == "4006")
            //{
            //    var gs = targets.GroupBy(p => p < 4087).ToArray();
            //    flag = !flag;
            //    var targetG = gs.OrderBy(v => v.Key == flag).First();

            //    if (!targetG.Key)
            //    {
            //        obj.Data.TaskNumber = 4006;
            //        obj.Data.GoodsEnd = 4087;
            //        obj.Data.VoucherNo++;
            //        return;
            //    }
            //}

            if (obj.Entity.Code == "4006")
            {
                var arrnew = targets.Where(v => v < 4087).Select(v => new { Targget = v, Arr = DevicePath.GetPath(obj.Entity.Code, v.ToString()).Points.Select(d => d.Protocol<IStation521>(this.World)) }).ToArray();
                var arrnew1 = targets.Where(v => v > 4087).Select(v => new { Targget = v, Arr = DevicePath.GetPath("4087", v.ToString()).Points.Select(d => d.Protocol<IStation521>(this.World)) }).ToArray();

                var arr2new = arrnew.Select(v => new { Target = v.Targget, Qty = v.Arr.Where(d => d.TaskNumber > 0 && d.GoodsEnd == v.Targget).Count() });
                var arr3new = arrnew1.Select(v => new { Target = v.Targget, Qty = v.Arr.Where(d => d.TaskNumber > 0 && d.GoodsEnd == v.Targget).Count() });

                if (arr2new.Any(v => v.Target < 4087 && v.Qty < 3))
                {
                    var tar = arr2new.Where(v => v.Target < 4087 && v.Qty < 3).Select(p => p.Target);
                    //    target = arr2.Where(v => v.Target < 4087 && v.Qty <= 8).OrderBy(v => v.Qty >= 4)
                    //.ThenByDescending(v => v.Qty)
                    //.ThenByDescending(v => v.Target);
                    targets = targets.Where(v => v < 4087 && tar.Contains(v)).ToArray();
                    World.Log("机台分配记录:1");


                }
                else
                {
                    if (arr3new.Any(v => v.Target > 4087 && v.Qty < 3))
                    {
                        obj.Data.TaskNumber = 4006;
                        obj.Data.GoodsEnd = 4087;
                        obj.Data.VoucherNo++;
                        World.Log("机台分配记录:2");
                        return;
                    }
                    else
                    {
                        World.Log("机台分配记录:3");
                        World.Log($"扭转机台分配{obj.Entity.Code}交互结束时间:一个周期" + DateTime.Now.ToString("yyyyMMddHHmmss"));
                        MainWorld.Redis.Set($"Sx:WCSErrorInfo:{obj.Entity.Code}", JsonConvert.SerializeObject(new RedisError() { Equip = obj.Entity.Code, Con = $"{obj.Entity.Code}4087无可用机台", Time = DateTime.Now }));
                        throw new Exception("4087无可用机台");
                    }
                }
                //targets = targets.Where(v => v < 4087).ToArray();
            }
            else
            {
                //arr2 = arr2.Where(v => v.Target > 4087).ToArray();
                targets = targets.Where(v => v > 4087).ToArray();
            }
            if (targets.Length == 0)
            {
                World.Log($"扭转机台分配{obj.Entity.Code}交互结束时间:一个周期" + DateTime.Now.ToString("yyyyMMddHHmmss"));
                MainWorld.Redis.Set($"Sx:WCSErrorInfo:{obj.Entity.Code}", JsonConvert.SerializeObject(new RedisError() { Equip = obj.Entity.Code, Con = obj.Entity.Code + "无可用机台", Time = DateTime.Now }));
                throw new Exception("无可用机台");
            }
            World.Log("机台分配记录:4");
            var arr = targets.Select(v => new { Targget = v, Arr = DevicePath.GetPath(obj.Entity.Code, v.ToString()).Points.Select(d => d.Protocol<IStation521>(this.World)) }).ToArray();
            var arr2 = arr.Select(v => new { Target = v.Targget, Qty = v.Arr.Where(d => d.TaskNumber > 0 && d.GoodsEnd == v.Targget).Count() });
            var target = arr2.Where(p=>p.Qty < 3).OrderBy(v => v.Qty)
                 //.OrderBy(v => v.Qty >= 4)
                //.ThenByDescending(v => v.Qty)
                //.ThenByDescending(v => v.Target)
                .First();
            if (target == null)
            {
                throw new Exception("4087分配无可用机台");
            }
            obj.Data.TaskNumber = short.Parse(obj.Entity.Code);
            obj.Data.GoodsEnd = target.Target;
            obj.Data.VoucherNo++;

            SqlSugarHelper.Do(db =>
            {
                var torschs = db.Default.Queryable<TorschWbCount>().Where(p => p.Memo == target.Target.ToString()).First();
                if (torschs != null)
                {
                    db.Default.Updateable<TorschWbCount>()
                           .SetColumns(p => new TorschWbCount { WbCount = p.WbCount + 1 })
                            .Where(p => p.Id == torschs.Id)
                           .ExecuteCommand();
                }
            });
            World.Log($"扭转机台分配{obj.Entity.Code}交互结束时间:一个周期" + DateTime.Now.ToString("yyyyMMddHHmmss"));
        }

        public override bool Select(Device dev)
        {
            return dev.Code == "4006" || dev.Code == "4087";
        }
    }
}
