﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WCS.Core;
using WCS.Entity.Protocol.BCR;
using WCS.Entity.Protocol.Station;
using WCS.WorkEngineering.Worlds;
using WCS.WorkEngineering.Extensions;
using MySqlConnector;
using ServiceCenter.SqlSugars;
using WCS.Entity;
using WCS.WorkEngineering.WebApi.Models.WCS.Request;
using Newtonsoft.Json;
using NPOI.SS.Formula.Functions;
using ServiceCenter.Extensions;

namespace WCS.WorkEngineering.Systems.扭转检测
{
    [BelongTo(typeof(MainWorld))]
    [Description("进入机台")]
    public class EnterQT : DeviceSystem<Device<IStation520, IStation521, IStation523,IBCR81>>
    {
        protected override bool ParallelDo => false;
         

        public override void Do(Device<IStation520, IStation521, IStation523,IBCR81> obj)
        {
            if (obj.Data.VoucherNo != obj.Data2.VoucherNo)
            {
                World.Log("PLC正在处理");
                return;
            }
            if (obj.Data2.Request == 0)
            {
                var res = MainWorld.Redis.Get($"{obj.Entity.Code}");
                if (!string.IsNullOrEmpty(res))
                {
                    var redis = res.Split("|");
                    var vo = redis[0];
                    var tasks = redis[1];
                    var machine = string.Empty;
                    switch (obj.Entity.Code)
                    {
                        case "4019":
                            machine = "1";
                            break;
                        case "4042":
                            machine = "2";
                            break;
                        case "4049":
                            machine = "3";
                            break;
                        case "4072":
                            machine = "4";
                            break;
                        case "4079":
                            machine = "5";
                            break;
                        case "4096":
                            machine = "6";
                            break;
                        case "4119":
                            machine = "7";
                            break;
                        case "4126":
                            machine = "8";
                            break;
                        case "4149":
                            machine = "9";
                            break;
                        case "4156":
                            machine = "10";
                            break;
                        default:
                            break;
                    }
                    if (obj.Data.VoucherNo == vo.ToShort() && int.Parse(tasks) != obj.Data.TaskNumber)
                    {
                        var oldtask = "";
                        SqlSugarHelper.Do(db =>
                        {
                            oldtask = db.Default.Ado.SqlQuery<string>("select top(1) TaskNo from WMS_ZT_01SX.dbo.Base_Torchbandinfo where Machine = " + machine + "order by AddTime DESC").FirstOrDefault();
                        });
                        if (!string.IsNullOrEmpty(oldtask) && int.Parse(oldtask) == obj.Data.TaskNumber)
                        {
                            World.Log($"{obj.Entity.Code}任务重复,触发重写机制,触发前读取520任务号:" + obj.Data.TaskNumber + ",凭证号:" + obj.Data.VoucherNo );
                            obj.Data.TaskNumber = int.Parse(tasks);
                            obj.Data.VoucherNo++;
                            World.Log($"{obj.Entity.Code}任务重复,触发重写机制,重新写入任务号:" + tasks + ",凭证号:" + obj.Data.VoucherNo);
                            return;
                        }
                    }
                }
                World.Log("无请求");
                return;
            }
            var barcode = obj.Data4.Content.Replace("\r", "");
            if (string.IsNullOrEmpty(barcode))
            {
                MainWorld.Redis.Set($"Sx:WCSErrorInfo:{obj.Entity.Code}", JsonConvert.SerializeObject(new RedisError() { Equip = obj.Entity.Code, Con = $"扫码器{obj.Entity.Code}，{barcode}扫码失败", Time = DateTime.Now }));
                throw new Exception("扫码失败");
            }
            World.Log($"扭转机台扫码{obj.Entity.Code}交互开始时间:工字轮条码 {barcode} | " + DateTime.Now.ToString("yyyyMMddHHmmss"));
            World.Log($"获取81db块条码{barcode}");
            var taskid = 0;
            SqlSugarHelper.Do(db =>
            {
                var task = db.Default.Queryable<WCS_TaskInfo>().Where(v => v.BarCode == barcode).First();
                if (task == null)
                {
                    MainWorld.Redis.Set($"Sx:WCSErrorInfo:{obj.Entity.Code}", JsonConvert.SerializeObject(new RedisError() { Equip = obj.Entity.Code, Con = $"{obj.Entity.Code}，{barcode}此条码无任务信息", Time = DateTime.Now }));
                    throw new Exception("此条码无任务信息");
                }
                if (task.BusType != "扭转检测")
                {
                    MainWorld.Redis.Set($"Sx:WCSErrorInfo:{obj.Entity.Code}", JsonConvert.SerializeObject(new RedisError() { Equip = obj.Entity.Code, Con = $"{obj.Entity.Code}，{task.ID}任务不是去扭转检测的出库任务", Time = DateTime.Now }));
                    throw new Exception("任务类型错误");
                }
                taskid = task.ID;
                //obj.Data.TaskNumber = task.ID;
                //obj.Data.TaskNumber = task.ID;
                //if (obj.Data.TaskNumber == task.ID)
                //{
                //    obj.Data.VoucherNo++;
                //}
                //World.Log("进入机台记录:任务" + obj.Data.TaskNumber + "VoucherNo" + obj.Data.VoucherNo + "taskID"+ task.ID);
            });
            if (taskid > 0)
            {
                obj.Data.TaskNumber = taskid;
                if (obj.Data.TaskNumber == taskid)
                {
                    obj.Data.TaskNumber = taskid;
                    obj.Data.VoucherNo++;
                }
            }
            World.Log($"扭转机台扫码{obj.Entity.Code}交互结束时间:工字轮条码 {barcode} | " + DateTime.Now.ToString("yyyyMMddHHmmss"));
            World.Log("进入机台记录:任务" + obj.Data.TaskNumber + "VoucherNo" + obj.Data.VoucherNo + "taskID" + taskid);
            MainWorld.Redis.Set($"{obj.Entity.Code}", obj.Data.VoucherNo.ToString() + "|" + obj.Data.TaskNumber);
        }

        public override bool Select(Device dev)
        { 
            return dev.HasFlag("扭转检测");
        }
    }
}
