﻿using ServiceCenter.SqlSugars;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WCS.Core;
using WCS.Entity;
using WCS.Entity.Protocol.Station;
using WCS.WorkEngineering.Extensions;
using WCS.WorkEngineering.Worlds;

namespace WCS.WorkEngineering.Systems
{
    [BelongTo(typeof(MainWorld))]
    [Description("码垛出库排序")]
    public class 码垛出库排序 : DeviceSystem<Device<IStation23>>
    {
        protected override bool ParallelDo => true;
         
        public override void Do(Device<IStation23> obj)
        { 
            if (obj.Data.ReadQty > 0)
                return;
            if (obj.Data.TaskArray[0] == 0)
                return;

            SqlSugarHelper.Do(db =>
            {
                short qty = 0;
                foreach (var taskid in obj.Data.TaskArray)
                {
                    World.Log("码垛出库排序插数据开始:taskid-" + taskid);
                    if (taskid == 0)
                        break;
                   //var res =  db.Default.Insertable(new WCS_TaskOutSeq
                   // {
                   //     TaskID = taskid,
                   // }).ExecuteCommand();
                    World.Log("码垛出库排序插数据结果:结果-" + "taskid-" + taskid);

                    var task = db.Default.Queryable<WCS_TaskInfo>().Where(v => v.ID == taskid&&v.Status<= Entity.TaskStatus.码垛合流).First();
                    if (task != null && task.BusType == "装箱码垛")
                    {
                        task.Status = Entity.TaskStatus.码垛合流;
                        task.EditTime= DateTime.Now;
                        db.Default.Updateable(task).ExecuteCommand();
                        task.AddWCS_TASK_DTL(db.Default, obj.Entity.Code, "码垛合流");
                    }

                    qty++;
                }
                if (qty > 0)
                {
                    obj.Data.ReadQty = qty;
                }
            });
            
        }

        public override bool Select(Device dev)
        {
            return true;
        }
    }
}
