﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WCS.WorkEngineering
{
    public class Response
    {  /// <summary>
       /// 返回状态码
       /// </summary>
        public int ResCode { get; set; } = 200;

        public bool Success
        {
            get
            {
                return ResCode == 200;
            }
        }

        /// <summary>
        /// 返回描述信息
        /// </summary>
        public string ResMsg { get; set; } = "成功";

        /// <summary>
        /// 备用
        /// </summary>
        public string Memo1 { get; set; }
        /// <summary>
        /// 备用
        /// </summary>
        public string Memo2 { get; set; }
        /// <summary>
        /// 备用
        /// </summary>
        public string Memo3 { get; set; }
    }

    public class Response<T> : Response
    { 
        public T ResData { get; set; }
    }


    public class TaskAndFloor
    {
        public int TaskNo { get; set; }
        public short Floor { get; set; }
    } 

    public class LocationInfo
    {
        /// <summary>
        /// 货位号
        /// </summary>
        public string CellNo { get; set; }
        /// <summary>
        /// 巷道号
        /// </summary>
        public string TunnelNum { get; set; }
        /// <summary>
        /// 行
        /// </summary>
        public int Row { get; set; }
        /// <summary>
        /// 列
        /// </summary>
        public int Colomn { get; set; }
        /// <summary>
        /// 层
        /// </summary>
        public int Layer { get; set; }
        /// <summary>
        /// 货叉
        /// </summary>
        public int Fork { get; set; }
        /// <summary>
        /// 任务号
        /// </summary>
        public int TaskNo { get; set; }
    } 

}
